#define _WIN32_WINNT  0x0600
//#define  WINVER       0x0501
#define _WIN32_IE     0x0600

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>

/*#ifndef TTI_NONE
// ToolTip Icons (Set with TTM_SETTITLE)
#define TTI_NONE                0
#define TTI_INFO                1
#define TTI_WARNING             2
#define TTI_ERROR               3
#if (_WIN32_WINNT >= 0x0600)
#define TTI_INFO_LARGE          4
#define TTI_WARNING_LARGE       5
#define TTI_ERROR_LARGE         6
#endif  // (_WIN32_WINNT >= 0x0600)
#endif
*/
#include "win091.h"

/*  Declaracin del procedimiento de ventana  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
int InsertarItem(HWND hwndHeader, int iDespuesDe, int nAncho, LPTSTR lpsz, int *filtro);

int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)
{
    HWND hwnd;               /* Manipulador de ventana */
    MSG mensaje;             /* Mensajes recibidos por la aplicacin */
    WNDCLASSEX wincl;        /* Estructura de datos para la clase de ventana */


    /* Estructura de la ventana */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = "NUESTRA_CLASE";
    wincl.lpfnWndProc = WindowProcedure;      /* Esta funcin es invocada por Windows */
    wincl.style = CS_DBLCLKS;                 /* Captura los doble-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Usar icono y puntero por defector */
    wincl.hIcon = LoadIcon(hThisInstance, "icono");
    wincl.hIconSm = LoadIcon(hThisInstance, "icono");
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;                      /* Sin informacin adicional para la */
    wincl.cbWndExtra = 0;                      /* clase o la ventana */
    /* Usar el color de fondo por defecto para la ventana */
    wincl.hbrBackground =  GetSysColorBrush(COLOR_MENU); //COLOR_BACKGROUND);

    /* Registrar la clase de ventana, si falla, salir del programa */
    if(!RegisterClassEx(&wincl)) return 0;

    /* La clase est registrada, crear la ventana */
    hwnd = CreateWindowEx(
           0,                   /* Posibilidades de variacin */
           "NUESTRA_CLASE",     /* Nombre de la clase */
           "Ejemplo 091",       /* Texto del ttulo */
           WS_OVERLAPPEDWINDOW, /* Tipo por defecto */
           CW_USEDEFAULT,       /* Windows decide la posicin */
           CW_USEDEFAULT,       /* donde se coloca la ventana */
           250,                 /* Ancho */
           90,                  /* Alto en pixels */
           HWND_DESKTOP,        /* La ventana es hija del escritorio */
           NULL,                /* Sin men */
           hThisInstance,       /* Manipulador de instancia */
           NULL                 /* No hay datos de creacin de ventana */
    );

    InitCommonControls();
    /* Mostrar la ventana */
    ShowWindow(hwnd, SW_SHOWDEFAULT);

    /* Bucle de mensajes, se ejecuta hasta que haya error o GetMessage devuelva FALSE */
    while(TRUE == GetMessage(&mensaje, NULL, 0, 0))
    {
       if(!IsDialogMessage(hwnd, &mensaje) ) {
        /* Traducir mensajes de teclas virtuales a mensajes de caracteres */
        TranslateMessage(&mensaje);
        /* Enviar mensaje al procedimiento de ventana */
        DispatchMessage(&mensaje);
        }
    }
    /* Salir con valor de retorno */
    return mensaje.wParam;
}

/*  Esta funcin es invocada por la funcin DispatchMessage()  */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    /* Variables para dilogo */
    static HINSTANCE hInstance;
    static HFONT hFont;
    RECT rc;
    HDLAYOUT hdl;
    WINDOWPOS wp;
    LPNMHEADER pnmhdr;
    int iItem;
    HDITEM hdi;
    char mensaje[128];
    static int filtro[3] = {100, 200, 300};

    switch (msg)              /* manipulador del mensaje */
    {
        case WM_CREATE:
            hInstance = ((LPCREATESTRUCT)lParam)->hInstance;
            hFont = CreateFont(18, 0, 0, 0, 300, FALSE, FALSE, FALSE,
                DEFAULT_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS,
                PROOF_QUALITY, DEFAULT_PITCH | FF_ROMAN, "Times New Roman");
            CreateWindowEx(0, WC_HEADER, NULL,
                WS_CHILD | HDS_HORZ | HDS_DRAGDROP | HDS_BUTTONS | HDS_OVERFLOW | HDS_FILTERBAR | HDS_CHECKBOXES,
                0, 0, 0, 0,
                hwnd, (HMENU)ID_HEADER1,
                hInstance, NULL);
            // Asignamos la fuente a nuestro gusto.
            SendDlgItemMessage(hwnd, ID_HEADER1, WM_SETFONT, (WPARAM)hFont, MAKELPARAM(TRUE, 0));
            // Ajustar dimensiones y posicin en funcin de la ventana padre.
            GetClientRect(hwnd, &rc);
            hdl.prc = &rc;
            hdl.pwpos = &wp;
            SendDlgItemMessage(hwnd, ID_HEADER1, HDM_LAYOUT, 0, (LPARAM)&hdl);
            /* O bien la macro:
            Header_Layout(GetDlgItem(hwnd, ID_HEADER1), &hdl);
            */
            SetWindowPos(GetDlgItem(hwnd, ID_HEADER1), wp.hwndInsertAfter, wp.x, wp.y,
                wp.cx, wp.cy, wp.flags | SWP_SHOWWINDOW );
            // Insertar columnas.
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), 0, 90, "Item 1", &filtro[0]);
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), 1, 90, "Item 2", &filtro[1]);
            InsertarItem(GetDlgItem(hwnd, ID_HEADER1), 2, 90, "Item 3", &filtro[2]);
            return 0;
        case WM_SIZE:
            GetClientRect(hwnd, &rc);
            hdl.prc = &rc;
            hdl.pwpos = &wp;
            SendDlgItemMessage(hwnd, ID_HEADER1, HDM_LAYOUT, 0, (LPARAM)&hdl);
            SetWindowPos(GetDlgItem(hwnd, ID_HEADER1), wp.hwndInsertAfter, wp.x, wp.y,
                wp.cx, wp.cy, wp.flags);
            break;
        case WM_NOTIFY:
            pnmhdr = (LPNMHEADER)lParam;
            switch(pnmhdr->hdr.code) {
                case HDN_GETDISPINFO:
                    MessageBox(hwnd, "GETDISPINFO", "Notificacion", MB_OK);
                    break;
                case NM_RCLICK:
                    MessageBox(hwnd, "Item clic derecho", "Click", MB_OK);
                    break;
                case HDN_ITEMKEYDOWN:
                    MessageBox(hwnd, "Item keydown", "Click", MB_OK);
                    break;
                case HDN_ITEMSTATEICONCLICK:
                    iItem = pnmhdr->iItem;
                    hdi.mask = HDI_FORMAT;
                    SendDlgItemMessage(hwnd, ID_HEADER1, HDM_GETITEM, (WPARAM)iItem, (LPARAM)&hdi);
                    if(hdi.fmt & HDF_CHECKED) hdi.fmt = (UINT)hdi.fmt & ~HDF_CHECKED;
                    else hdi.fmt |= HDF_CHECKED;
                    hdi.mask = HDI_FORMAT;
                    SendDlgItemMessage(hwnd, ID_HEADER1, HDM_SETITEM, (WPARAM)iItem, (LPARAM)&hdi);
                    break;
                case HDN_FILTERBTNCLICK:
                    iItem = pnmhdr->iItem+1;
                    sprintf(mensaje, "Botn de filtro de item %d activado", iItem);
                    MessageBox(hwnd, mensaje, "Filtro", MB_OK);
                    break;
                case HDN_DROPDOWN:
                    iItem = pnmhdr->iItem+1;
                    sprintf(mensaje, "Dropdown de item %d activado", iItem);
                    MessageBox(hwnd, mensaje, "Mensaje", MB_OK);
                    MessageBeep(MB_ICONHAND);
                    return FALSE;
            }
            break;
        case WM_DESTROY:
           DeleteObject(hFont);
           PostQuitMessage(0);    /* enva un mensaje WM_QUIT a la cola de mensajes */
           break;
        default:                  /* para los mensajes de los que no nos ocupamos */
           return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}

int InsertarItem(HWND hwndHeader, int iDespuesDe, int nAncho, LPTSTR lpsz, int *numero)
{
    HDITEM hdi;
    int index;


    hdi.mask = HDI_TEXT | HDI_FORMAT | HDI_WIDTH | HDI_FILTER;
    hdi.cxy = nAncho;
    hdi.pszText = lpsz;
    hdi.cchTextMax = strlen(hdi.pszText)/sizeof(hdi.pszText[0]);
    hdi.fmt = HDF_STRING | HDF_CHECKBOX | HDF_CHECKED | HDF_CENTER | HDF_SPLITBUTTON; // | HDF_SORTUP
    hdi.type = HDFT_ISNUMBER;
    hdi.pvFilter = numero;
    index = SendMessage(hwndHeader, HDM_INSERTITEM,
        (WPARAM) iDespuesDe, (LPARAM) &hdi);

    return index;
}
